#include "lfn.h"
#include <stdio.h>
#include <stdlib.h>

#define FILE_NAME	argv[1]
#define FILE_NAME_2	"different file name"

#define ACCESS_MODE 		\
		OPEN_ACCESS_READWRITE|	\
		OPEN_SHARE_COMPATIBLE|	\
		OPEN_FLAGS_ALIAS_HINT|	\
		OPEN_FLAGS_NOCRTERR|	\
		OPEN_FLAGS_COMMIT

int main(int argc , char **argv)
{
	
	WORD action;
	WORD read, written;
	HFILE fhandle;

	char buf_write[] = {
		"Text mode file and archive manager     \n"
		"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     \n"
		"- Long file names support              \n"
		"- User defined view modes              \n"
		"- File descriptions and highlighting   \n"
		"- User menu, file associations         \n"
		"- FTP client, network browser          \n"
		"- Task list and control		\n"
	};

	char buf_read[1024];

	if (argc < 3) {
		puts("Usage tfind2  filename type");
		puts("\t1 LONG_CREATE_FILE_OPEN		   ");
		puts("\t2 LONG_CREATE_FILE_TRUNCATE        ");
		puts("\t3 LONG_CREATE_FILE_CREATE          "); 
		puts("\t4 LONG_CREATE_FILE_CREATE_OPEN 	   ");
		puts("\t5 LONG_CREATE_FILE_CREATE_TRUNCATE ");
		exit(0);
	}	               	

	switch (atol(argv[2]))
	{                        	
		case 1:
			action = LONG_CREATE_FILE_OPEN		;
			break;                                  ;
		case 2:
			action = LONG_CREATE_FILE_TRUNCATE      ; 
			break;                                  ;
		case 3:
			action = LONG_CREATE_FILE_CREATE        ; 
			break;                                  ;
		case 4:
			action = LONG_CREATE_FILE_CREATE_OPEN 	;
			break;                                  ;
		case 5:
			action = LONG_CREATE_FILE_CREATE_TRUNCATE;
			break;                                   ;
		default:
			puts("Usage tfind2  filename type");
			puts("\t1 LONG_CREATE_FILE_OPEN		   ");
			puts("\t2 LONG_CREATE_FILE_TRUNCATE        ");
			puts("\t3 LONG_CREATE_FILE_CREATE          "); 
			puts("\t4 LONG_CREATE_FILE_CREATE_OPEN 	   ");
			puts("\t5 LONG_CREATE_FILE_CREATE_TRUNCATE ");
			exit(0);
	}

        buf_read[0] = '\0';
	
	fhandle = create_file(
		FILE_NAME, 
		ACCESS_MODE, 
		FILE_ATTR_NORMAL, 
        	&action,
		32);
	if (__lfnerrno !=0)
		return 1;

	switch (action)
	{
		case LONG_CREATE_FILE_OPENED  :
		case LONG_CREATE_FILE_CREATED_OPENED :
		case LONG_CREATE_FILE_REPLACED_OPENED:
			printf("created file handle: %u\n", fhandle);
			break;
		default:
			printf("unrecognized action: value %u\n", action);
			break;
	}

	read = written = 0;

	write_file(
		fhandle,
		buf_write,
		sizeof buf_write,
		&written);
	if (__lfnerrno !=0) {
		close_file(fhandle);	
		return 1;
	}

        lseek(
		fhandle,
		0,
		LSEEK_START_FILE_POS);

	read_file(
		fhandle,
		buf_read,
		sizeof buf_read,
		&read);
	if (__lfnerrno == 0) {
		printf("written %u, read %u\n", written, read);
		printf("%s\n", buf_read);
	}
 
 	close_file(fhandle);
/*
	rename_file(FILE_NAME, FILE_NAME_2);	

	delete_file(
		FILE_NAME_2, 
		LONG_DELETE_FILE_NO_WILDCARDS,
		FILE_ATTR_NORMAL,		
		FILE_ATTR_NORMAL);
	if (__lfnerrno !=0)
		return 1;
*/
	return 0;
}

