#include "lfn.h"
#include <stdio.h>
#include <string.h>

#define	filename	"very"

void    printf_fileattrs(union fileattrs fa, BYTE mode);
void    set_fileattrs(union fileattrs *fa, BYTE mode);
void	printf_dt(const char *s,struct datetime dt);

int main()
{
	WORD action;
	union fileattrs fa;
	struct datetime dt;

	action = LONG_GET_SET_FILE_ATTR_GET_WRITE_DATE;   	
	get_set_file_attributes(filename, action, &fa);
	if (__lfnerrno == 0) 
                printf_fileattrs(fa, action);	
	else
		puts("error");

	action = LONG_GET_SET_FILE_ATTR_SET_WRITE_DATE;   	
	set_fileattrs(&fa, action);
	get_set_file_attributes(filename, action, &fa);
	if (__lfnerrno == 0) 
                printf_fileattrs(fa, action);	
	else
		puts("error");

	action = LONG_GET_SET_FILE_ATTR_GET_ACCESS_DATE;  	
	get_set_file_attributes(filename, action, &fa);
	if (__lfnerrno == 0) 
                printf_fileattrs(fa, action);	
	else
		puts("error");

	action = LONG_GET_SET_FILE_ATTR_SET_ACCESS_DATE;  	
	set_fileattrs(&fa, action);
	get_set_file_attributes(filename, action, &fa);
	if (__lfnerrno == 0) 
                printf_fileattrs(fa, action);	
	else
		puts("error");

	action = LONG_GET_SET_FILE_ATTR_GET_CREATION_DATE; 	
	get_set_file_attributes(filename, action, &fa);
	if (__lfnerrno == 0) 
                printf_fileattrs(fa, action);	
	else
		puts("error");

	action = LONG_GET_SET_FILE_ATTR_SET_CREATION_DATE; 	
	set_fileattrs(&fa, action);
	get_set_file_attributes(filename, action, &fa);
	if (__lfnerrno == 0) 
                printf_fileattrs(fa, action);	
	else
		puts("error");

	action = LONG_GET_SET_FILE_ATTR_DRIVE_PHYS_SIZE;
	get_set_file_attributes(filename, action, &fa);
	if (__lfnerrno == 0) 
                printf_fileattrs(fa, action);	
	else
		puts("error");

	return 0;
}


void    set_fileattrs(union fileattrs *fa, BYTE mode)
{
	memset(fa, 0, sizeof (union fileattrs));
	switch (mode)
	{
		case LONG_GET_SET_FILE_ATTR_GET_ATTR		:		
			break;
		case LONG_GET_SET_FILE_ATTR_SET_ATTR         	:
			fa->attributes |= FILE_ATTR_ARCHIVE;
			break;
		case LONG_GET_SET_FILE_ATTR_DRIVE_PHYS_SIZE  	:
			break;
		case LONG_GET_SET_FILE_ATTR_SET_WRITE_DATE   	:
			fa->dt.t.seconds =  11;
			fa->dt.t.minutes =  12;
			fa->dt.t.hours   =  13;
			fa->dt.d.day= 2;
			fa->dt.d.month=2;
			fa->dt.d.year=18;
			break;
		case LONG_GET_SET_FILE_ATTR_GET_WRITE_DATE   	:
			break;
		case LONG_GET_SET_FILE_ATTR_SET_ACCESS_DATE  	:
			fa->dt.t.seconds =  21;
			fa->dt.t.minutes =  22;
			fa->dt.t.hours   =  23;
			fa->dt.d.day= 3;
			fa->dt.d.month=3;
			fa->dt.d.year=19;
			break;
		case LONG_GET_SET_FILE_ATTR_GET_ACCESS_DATE  	:
			break;
		case LONG_GET_SET_FILE_ATTR_SET_CREATION_DATE 	:
			fa->dt.t.seconds =  1;
			fa->dt.t.minutes =  2;
			fa->dt.t.hours   =  3;
			fa->dt.d.day= 1;
			fa->dt.d.month= 1;
			fa->dt.d.year=17;
			break;
		case LONG_GET_SET_FILE_ATTR_GET_CREATION_DATE 	:
			break;
        	default:
			printf("unknown action %u\n", mode);
			break;
	}
}

void    printf_fileattrs(union fileattrs fa, BYTE mode)
{
	switch (mode)
	{
		case LONG_GET_SET_FILE_ATTR_GET_ATTR		:		
		case LONG_GET_SET_FILE_ATTR_SET_ATTR         	:	
			printf("file attributes %x\n", fa.attributes);
			if (fa.attributes & FILE_ATTR_NORMAL		) puts("NORMAL	");	
			if (fa.attributes & FILE_ATTR_READONLY       	) puts("READONLY       ");       
			if (fa.attributes & FILE_ATTR_HIDDEN            ) puts("HIDDEN         ");  
			if (fa.attributes & FILE_ATTR_SYSTEM            ) puts("SYSTEM         ");  
			if (fa.attributes & FILE_ATTR_VOLUME_LABEL      ) puts("VOLUME_LABEL   ");  
			if (fa.attributes & FILE_ATTR_DIRECTORY         ) puts("DIRECTORY      ");  
			if (fa.attributes & FILE_ATTR_ARCHIVE           ) puts("ARCHIVE        ");  
			if (fa.attributes & FILE_ATTR_PENDING_DELETED   ) puts("PENDING_DELETED");  
			break;
		case LONG_GET_SET_FILE_ATTR_SET_WRITE_DATE   	:
		case LONG_GET_SET_FILE_ATTR_GET_WRITE_DATE   	:
			printf_dt("get write date", fa.dt);
			break;
		case LONG_GET_SET_FILE_ATTR_SET_ACCESS_DATE  	:
		case LONG_GET_SET_FILE_ATTR_GET_ACCESS_DATE  	:
			printf_dt("get access date", fa.dt);
			break;
		case LONG_GET_SET_FILE_ATTR_SET_CREATION_DATE 	:
		case LONG_GET_SET_FILE_ATTR_GET_CREATION_DATE 	:
			printf_dt("get creation date", fa.dt);
			break;
		case LONG_GET_SET_FILE_ATTR_DRIVE_PHYS_SIZE  	:
			printf("size %lu\n", fa.size);
			break;
        	default:
			puts("invalid action specified");
			break;
        }
}


void	printf_dt(const char *s, struct datetime dt)
{
#if 0
	printf("value:  %u\n", *(DWORD *)&dt );
	printf("seconds %u\n",	DT_GET_TIME_SECONDS(dt));
	printf("minutes %u\n",	DT_GET_TIME_MINUTES(dt));
	printf("hours   %u\n",	DT_GET_TIME_HOURS(dt));
	printf("day     %u\n",	DT_GET_DATE_DAY(dt));
	printf("month   %u\n",	DT_GET_DATE_MONTH(dt));
	printf("year    %u\n",	DT_GET_DATE_YEAR(dt));
	printf("milsecs %u\n", DT_GET_MILISECS(dt));    
#endif
	printf("%020s: %02d/%02d/%d %02d:%02d\n",
		s,
                DT_GET_DATE_MONTH(dt), 
		DT_GET_DATE_DAY(dt), 
		DT_GET_DATE_YEAR(dt), 
		DT_GET_TIME_HOURS(dt), 
		DT_GET_TIME_MINUTES(dt));
}

