#include "lfn.h"
#include <stdio.h>
#include <string.h>

#define ACCESS_MODE 		\
		OPEN_ACCESS_READWRITE|	\
		OPEN_SHARE_COMPATIBLE|	\
		OPEN_FLAGS_NOCRTERR|	\
		OPEN_FLAGS_COMMIT

void	printf_fileinfo(struct fileinfo finfo);
void	printf_dt(struct datetime dt);
char * 	dtstr( FILETIME *org_dt);

int main()
{
	HFILE handle;	
	WORD action;
	WORD written;

	char filename[260];
	struct fileinfo finfo;
	struct datetime dt;

	char buf_write[] = {
		"Text mode file and archive manager     \n"
		"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     \n"
		"- Long file names support              \n"
		"- User defined view modes              \n"
		"- File descriptions and highlighting   \n"
		"- User menu, file associations         \n"
		"- FTP client, network browser          \n"
		"- Task list and control		\n"
	};

	puts("Enter filename");
	scanf("%s",filename);
	
	action = LONG_CREATE_FILE_CREATE_OPEN;

	handle = create_file(
		filename, 
		ACCESS_MODE, 
		FILE_ATTR_NORMAL, 
        	&action,
		0);
	if (__lfnerrno != 0) 
		return 1;

	write_file(
		handle,
		buf_write,
		sizeof buf_write,
		&written);
	if (__lfnerrno !=0) {
		close_file(handle);	
		return 1;
	}

	memset(&finfo, 0, sizeof finfo);

	get_file_information(handle, &finfo);
	if (__lfnerrno == 0)
		printf_fileinfo(finfo);
/*
	get_creation_date(
		handle, 
		&dt);
	if (__lfnerrno == 0) 
		printf_dt(dt);
	

	get_last_access_date(
		handle, 
		&dt);
	if (__lfnerrno == 0) 
		printf_dt(dt);

	dt.t.seconds =  21;
	dt.t.minutes =  22;
	dt.t.hours   =  23;
	dt.d.day= 3;
	dt.d.month=3;
	dt.d.year=19;

	set_creation_date(
		handle, 
		&dt);

	dt.t.seconds =   1;
	dt.t.minutes =   2;
	dt.t.hours   =   3;
	dt.d.day= 13;
	dt.d.month=9;
	dt.d.year=19;

	set_last_access_date(
		handle, 
		&dt);

	get_creation_date(
		handle, 
		&dt);
	if (__lfnerrno == 0) 
		printf_dt(dt);

	get_last_access_date(
		handle, 
		&dt);
	if (__lfnerrno == 0) 
		printf_dt(dt);
*/
 	close_file(handle);

	delete_file(
		filename, 
		LONG_DELETE_FILE_NO_WILDCARDS,
		FILE_ATTR_NORMAL,		
		FILE_ATTR_NORMAL);
	if (__lfnerrno !=0)
		return 1;

	return 0;
}

void	printf_fileinfo(struct fileinfo finfo)
{
	printf("file attributes                       %lu\n",finfo.fattr);
		
	if (finfo.fattr & FILE_ATTR_NORMAL		) puts("NORMAL	");	
	if (finfo.fattr & FILE_ATTR_READONLY       	) puts("READONLY       ");       
	if (finfo.fattr & FILE_ATTR_HIDDEN              ) puts("HIDDEN         ");  
	if (finfo.fattr & FILE_ATTR_SYSTEM              ) puts("SYSTEM         ");  
	if (finfo.fattr & FILE_ATTR_VOLUME_LABEL        ) puts("VOLUME_LABEL   ");  
	if (finfo.fattr & FILE_ATTR_DIRECTORY           ) puts("DIRECTORY      ");  
	if (finfo.fattr & FILE_ATTR_ARCHIVE             ) puts("ARCHIVE        ");  
	if (finfo.fattr & FILE_ATTR_PENDING_DELETED     ) puts("PENDING_DELETED");  

	printf("creation time (0 = unsupported)       %s\n",dtstr(&finfo.creation_time));
	printf("last access time (0 = unsupported)    %s\n",dtstr(&finfo.access_time));
	printf("last write time                       %s\n",dtstr(&finfo.write_time));
	printf("volume serial number                  %lu\n",finfo.volumeID);
	printf("high 32 bits of file size             %lu\n",finfo.hi_filesize);
	printf("low 32 bits of file size              %lu\n",finfo.lo_filesize);
	printf("number of links to file               %lu\n",finfo.links);
	printf("unique file identifier (high 32 bits) %lu\n",finfo.hi_fileID);
	printf("unique file identifier (low 32 bits)  %lu\n",finfo.lo_fileID);
}

char * dtstr( FILETIME *org_dt)
{
	struct datetime dt;
	static char buf[64];

	memset(&dt, 0, sizeof dt);

	convert_time(
		&dt, 
		org_dt, 
		LONG_CONVERT_TIME_TO_DOS);

	sprintf(buf,"%02u/%02u/%4u %02u:%02u:%02u"   
		,DT_GET_DATE_MONTH(dt)
		,DT_GET_DATE_DAY(dt)
		,DT_GET_DATE_YEAR(dt)
		,DT_GET_TIME_HOURS(dt)
		,DT_GET_TIME_MINUTES(dt)
		,DT_GET_TIME_SECONDS(dt)
					);
	return buf;
}


void	printf_dt(struct datetime dt)
{
	printf("value:  %u\n", *(DWORD *)&dt );
	printf("seconds %u\n",	DT_GET_TIME_SECONDS(dt));
	printf("minutes %u\n",	DT_GET_TIME_MINUTES(dt));
	printf("hours   %u\n",	DT_GET_TIME_HOURS(dt));
	printf("day     %u\n",	DT_GET_DATE_DAY(dt));
	printf("month   %u\n",	DT_GET_DATE_MONTH(dt));
	printf("year    %u\n",	DT_GET_DATE_YEAR(dt));
	printf("milsecs %u\n", DT_GET_MILISECS(dt));    
	return;  
}