#include "lfn.h"
#include <stdio.h>
#include <string.h>

#define	FILE_NAME	"very long file name 1234567890"
#define ACCESS_MODE 		\
		OPEN_ACCESS_READWRITE|	\
		OPEN_SHARE_COMPATIBLE|	\
		OPEN_FLAGS_NOCRTERR|	\
		OPEN_FLAGS_COMMIT

int main()
{
	int m0, m1;
	HFILE handle;	
	WORD action;
	WORD written;
	char filename[260];

	int format_t[] = 
		{LONG_GENERATE_SHORT_NAME_FCB
		,LONG_GENERATE_SHORT_NAME_DOS
		};

	int charset_t[] = 
		{LONG_GENERATE_SHORT_NAME_CHARSET(CHARSET_WINDOWS_ANSI, CHARSET_WINDOWS_ANSI)				
		,LONG_GENERATE_SHORT_NAME_CHARSET(CHARSET_CURRENT_OEM, CHARSET_WINDOWS_ANSI)
		,LONG_GENERATE_SHORT_NAME_CHARSET(CHARSET_UNICODE, CHARSET_WINDOWS_ANSI)
		,LONG_GENERATE_SHORT_NAME_CHARSET(CHARSET_WINDOWS_ANSI, CHARSET_CURRENT_OEM) 				
		,LONG_GENERATE_SHORT_NAME_CHARSET(CHARSET_CURRENT_OEM, CHARSET_CURRENT_OEM)
		,LONG_GENERATE_SHORT_NAME_CHARSET(CHARSET_UNICODE, CHARSET_CURRENT_OEM)
		,LONG_GENERATE_SHORT_NAME_CHARSET(CHARSET_WINDOWS_ANSI, CHARSET_UNICODE)			
		,LONG_GENERATE_SHORT_NAME_CHARSET(CHARSET_CURRENT_OEM, CHARSET_UNICODE)
		,LONG_GENERATE_SHORT_NAME_CHARSET(CHARSET_UNICODE, CHARSET_UNICODE)
		};

	char buf_write[] = {
		"Text mode file and archive manager     \n"
		"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     \n"
		"- Long file names support              \n"
		"- User defined view modes              \n"
		"- File descriptions and highlighting   \n"
		"- User menu, file associations         \n"
		"- FTP client, network browser          \n"
		"- Task list and control		\n"
	};


	strcpy(filename, FILE_NAME);
	
	action = LONG_CREATE_FILE_CREATE_OPEN;

	handle = create_file(
		FILE_NAME, 
		ACCESS_MODE, 
		FILE_ATTR_NORMAL, 
        	&action,
		0);
	if (__lfnerrno != 0) 
		return 1;

	write_file(
		handle,
		buf_write,
		sizeof buf_write,
		&written);
	if (__lfnerrno !=0) {
		close_file(handle);	
		return 1;
	}

	for (m0=0; m0 < (sizeof format_t)/sizeof (int); m0++)
	{
		BYTE format = format_t[m0];

		for (m1=0; m1 < (sizeof charset_t)/sizeof (int); m1++)
		{	
			char shortname[14];
			BYTE charset = charset_t[m1];
	
			shortname[0] = '\0';
			generate_short_filename (filename, shortname, format, charset);
			if (__lfnerrno == 0) 
	        	        printf("longname, shortname: %s, %s\n", filename, shortname);
			else
				printf("format %u, charset %u, m1 %u\n", format, charset, m1);
		}
	}		

 	close_file(handle);

	delete_file(
		FILE_NAME, 
		LONG_DELETE_FILE_NO_WILDCARDS,
		FILE_ATTR_NORMAL,		
		FILE_ATTR_NORMAL);
	if (__lfnerrno !=0)
		return 1;

	return 0;
}

